package LeidenUniv.Tracking;
import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.plugin.frame.*;
import org.apache.commons.lang3.*;
import ij.measure.*;
import java.util.*;
import javax.imageio.*;
import java.net.*;
public class SpeedHeatMap {
	static ImagePlus imp10;

	public void run(float[][] XM, float[][] YM, ImagePlus imp, double rad, String dir) {
		Calibration cal = imp.getCalibration();
		ImagePlus imp2 = IJ.createImage("summed", "16-bit black", imp.getWidth() , imp.getHeight(), 1);
		ImagePlus imp3 = IJ.createImage("Track Heat Map", "16-bit black", imp.getWidth() , imp.getHeight(), 1);
		ImagePlus imp5 = IJ.createImage("Red Direction", "16-bit black", imp.getWidth() , imp.getHeight(), 1);
		ImagePlus imp6 = IJ.createImage("Green Direction", "16-bit black", imp.getWidth() , imp.getHeight(), 1);
		ImagePlus imp7 = IJ.createImage("Blue Direction", "16-bit black", imp.getWidth() , imp.getHeight(), 1);
		ImagePlus imp20 = IJ.createImage("All Direction", "16-bit black", imp.getWidth() , imp.getHeight(), 1);
		imp2.setCalibration(cal);
		imp3.setCalibration(cal);
		imp5.setCalibration(cal);
		ImageProcessor ip2= imp2.getProcessor();
		ImageProcessor ip3= imp3.getProcessor();
		ImageProcessor ip5= imp5.getProcessor();
		ImageProcessor ip6= imp6.getProcessor();
		ImageProcessor ip7= imp7.getProcessor();
		ImageProcessor ip20= imp20.getProcessor();
		RoiManager rm2 = new RoiManager(true);
		rm2.setVisible(true);
		for (int i=XM.length-1;i>=0;i--){
			float [] XMT =XM[i];
			float [] YMT =YM[i];
			/*for (int j=XM[i].length-1;j>=0;j--){
				XMT[j] =(XM[i][j]);
				YMT[j] =(YM[i][j]);
			}*/
			for (int j=XM[i].length-2;j>=0;j--){
				if (!((XM[i][j]==0&&YM[i][j]==0)||(XM[i][j+1]==0&&YM[i][j+1]==0))){
					
					int dis = (int)Math.sqrt((XM[i][j]-XM[i][j+1]) *(XM[i][j]-XM[i][j+1])+(YM[i][j]-YM[i][j+1]) *(YM[i][j]-YM[i][j+1]));
					Line S1 = new Line(XM[i][j]/cal.pixelWidth, YM[i][j]/cal.pixelWidth, XM[i][j+1]/cal.pixelWidth, YM[i][j+1]/cal.pixelWidth);
					double angle = S1.getAngle((int)XM[i][j], (int)YM[i][j], (int)XM[i][j+1], (int)YM[i][j+1]);
					int Radd=0;
					int Gadd=0;
					int Badd=0;
					if (angle >-120 && angle <120){
						Radd=(int)(240-2*(Math.abs(angle)));
					}
					if (angle <0 || angle >120){
						if (angle>120){
							Badd=(int)((angle-120)*2);
						} else if (angle<-120) {
							Badd=(int)(240+(120+angle)*2);
						} else {
							Badd=(int)(Math.abs(angle)*2);
						}
							
					}
					if (angle >0 || angle <-120){
						if (angle<120&& angle>0){
							Gadd=(int)(angle*2);
						} else if (angle>0 && angle <180){
							Gadd=(int)(240-(angle-120)*2);
						} else if (angle<-120){
							Gadd=(int)(Math.abs((angle+120)*2));
						}
					}
					S1.setWidth((int) rad);
					imp2.setRoi(S1);
					Rectangle R1 = S1.getBounds();
					// now we loop through the pixels in the new images to update their values
					//IJ.log(" G "+Gadd+" R "+Radd+" B "+Badd +" angle "+angle);
					for (int k=R1.x-10; k<R1.x+R1.width+rad;k++){ // loop through x
						for (int l =R1.y-10; l<R1.y+R1.height+rad;l++){
							if (S1.contains(k,l)){
								ip2.set(k,l,dis+ip2.get(k,l));
								ip3.set(k,l,1+ip3.get(k,l));
								ip5.set(k,l,Radd+ip5.get(k,l));
								ip6.set(k,l,Gadd+ip6.get(k,l));
								ip7.set(k,l,Badd+ip7.get(k,l));
								ip20.set(k,l,(int)angle+180+ip20.get(k,l));
							}
						}
					}
				} else if ((XM[i][j]==0&&YM[i][j]==0)) {
					XMT=ArrayUtils.remove(XMT,j);
					YMT=ArrayUtils.remove(YMT,j);
				} else {
					XMT=ArrayUtils.remove(XMT,j+1);
					YMT=ArrayUtils.remove(YMT,j+1);
				}
			}
			// here we can make the new roi file with tracks
			Roi cRoi = new PolygonRoi(XMT, YMT,XMT.length, Roi.POLYLINE);
			cRoi.setName(""+i);
			rm2.addRoi(cRoi);
		}
		rm2.runCommand("Save", dir+"\\TrackSet.zip");
		IJ.run(imp2, "Enhance Contrast", "saturated=0.0");
		IJ.run(imp3, "Enhance Contrast", "saturated=0.0");
		ImagePlus imp8= new ImagePlus();
		
		IJ.run(imp2, "Fire", "");
		IJ.run(imp3, "Fire", "");
		
		ImageCalculator ic = new ImageCalculator();
		ImagePlus imp4 = ic.run("Divide create 32-bit", imp2, imp3);
		imp5 = ic.run("Divide create 32-bit", imp5, imp3);
		imp6 = ic.run("Divide create 32-bit", imp6, imp3);
		imp7 = ic.run("Divide create 32-bit", imp7, imp3);
		imp20 = ic.run("Divide create 32-bit", imp20, imp3);
		IJ.setMinAndMax(imp5, 0, 240);
		IJ.setMinAndMax(imp6, 0, 240);
		IJ.setMinAndMax(imp7, 0, 240);

		imp5.setTitle("Red Direction");
		imp6.setTitle("Green Direction");
		imp7.setTitle("Blue Direction");

		String Pdir =IJ.getDirectory("plugins");
		URL url = null;
		// imp10 is colorwheel
		ImagePlus imp10 = IJ.createImage("wheel", "8-bit black", 100, 100, 1);
		IJ.run(imp10, "Macro...", "code=[if (d>=00 && d<=50) v=floor(a*256/2/PI)]");
		imp10.show();
		IJ.run("Spectrum");
		IJ.run(imp10, "RGB Color", "");
		ImagePlus msk = IJ.createImage("mask", "8-bit black", 100, 100, 1);
		IJ.run(msk, "Macro...", "code=[if (d>00 && d<50) v=255]");
		IJ.run(msk, "RGB Color", "");
		ic = new ImageCalculator();
		imp10 = ic.run("AND", imp10, msk);
		imp10 = IJ.getImage();
		imp20.show();
		
		// merge three colors for direction image.
		ImagePlus [] stack = new ImagePlus[] {imp5, imp6, imp7};
		ImagePlus rgb = RGBStackMerge.mergeChannels(stack, false);
		rgb.show();
		/*imp5.show();
		imp6.show();
		imp7.show();
		IJ.run(imp8, "Merge Channels...", "c1=[Red Direction] c2=[Green Direction] c3=[Blue Direction] create");
		imp8=IJ.getImage();*/
		IJ.run(rgb, "Stack to RGB","");
		ImagePlus imp9 = IJ.getImage();
		IJ.run(imp9, "Add Image...", "image=wheel x=0 y=0 opacity=100 zero");
		rgb.hide();
		rgb.close();

		IJ.saveAs(imp3, "Tiff", dir+"\\TrackHeatMap.tif");
		IJ.run(imp4, "Enhance Contrast", "saturated=0.0");
		IJ.run(imp4, "Fire", "");
		imp4.setTitle("Speed Map");
		imp9.setTitle("Direction Map");
		IJ.saveAs(imp4, "Tiff", dir+"\\SpeedMap.tif");
		IJ.saveAs(imp9, "Tiff", dir+"\\DirectionMap.tif");
		imp9.hide();
		rm2.close();
		msk.hide();
		imp20.hide();
		//imp10.close();
		imp4.close();
		imp3.close();
		imp5.close();
		imp6.close();
		imp7.close();
		imp8.close();
		imp9.close();
		msk.close();
		imp10.hide();
	}

}
